Package: Path2PPI
Type: Package
Title: Prediction of pathway-related protein-protein interaction
        networks
Version: 1.41.0
Date: 2016-03-02
Authors@R: c(
    person("Oliver", "Philipp", 
    email = "contact@oliverphilipp.info", 
    role = c("aut","cre")),
    person("Ina", "Koch", 
    email = "ina.koch@bioinformatik.uni-frankfurt.de", 
    role = "ctb")
    )
Maintainer: Oliver Philipp <contact@oliverphilipp.info>
Description: Package to predict protein-protein interaction (PPI) networks in 
    target organisms for which only a view information about 
    PPIs is available. Path2PPI predicts PPI networks based on sets of 
    proteins which can belong to a certain pathway from well-established model 
    organisms. It helps to combine and transfer information of a certain 
    pathway or biological process from several reference organisms to one 
    target organism. Path2PPI only depends on the sequence similarity of the 
    involved proteins.
License: GPL (>= 2)
URL: http://www.bioinformatik.uni-frankfurt.de/
Depends: R (>= 3.2.1), igraph (>= 1.0.1), methods
Suggests: knitr, rmarkdown, RUnit, BiocGenerics, BiocStyle
VignetteBuilder: knitr
Author: Oliver Philipp [aut, cre],
  Ina Koch [ctb]
biocViews: NetworkInference, SystemsBiology, Network, Proteomics,
        Pathways
git_url: https://git.bioconductor.org/packages/Path2PPI
git_branch: devel
git_last_commit: 382d4fd
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-30
NeedsCompilation: no
Packaged: 2025-10-30 22:20:30 UTC; biocbuild

setMethod("addReference",
          signature="Path2PPI",
          definition=function(path2ppi,taxName,taxId,
                              proteins,irefindex,homologs)
          {
            
            path2ppi@referenceContainer <- .addReferenceSpecies(
              path2ppi@referenceContainer,taxName,taxId,proteins,irefindex)
            
            #Load homology file and remove irrelevant homologs
            if (!is.data.frame(homologs)) {
              message("Load homologs file and remove irrelevant homologs.") 
              homologs <- read.table(file=homologs, sep="\t",quote="",
                                     header=FALSE,stringsAsFactors=FALSE)
            } else
              message("Remove irrelevant homologs.")
            
            proteins <- showReferences(path2ppi,taxId,"proteins")
            
            path2ppi@targetSpecies <- .addHomologs(
              path2ppi@targetSpecies,taxId,
              homologs[homologs[,2]%in%rownames(proteins),])
            
            path2ppi
          }
)

setMethod("showReferences",
          signature="Path2PPI",
          definition=function(path2ppi,species,returnValue)
          {
            if (.countSpecies(path2ppi@referenceContainer)>0) {
              if (!is.na(returnValue) && (returnValue!="proteins") && 
                    (returnValue!="interactions") && 
                    (returnValue!="irefindex"))
                stop("Wrong value for 'returnValue' parameter!")
              
              if (is.na(species)) {
                for (i in 1:.countSpecies(path2ppi@referenceContainer)) {
                  .getReferenceSpecies(path2ppi@referenceContainer, 
                                       i, info=TRUE)
                  cat("\n\n")
                }
              } else {
                if (is.na(returnValue))
                  .getReferenceSpecies(path2ppi@referenceContainer,species,
                                       info=TRUE)
                else {
                  species <- .getReferenceSpecies(path2ppi@referenceContainer,
                                                  species,info=FALSE)
                  if (returnValue=="proteins") 
                    return (species@proteins)
                  if (returnValue=="interactions") 
                    return (species@interactions)
                  if (returnValue=="irefindex") 
                    return (species@irefindex)
                }
                
              }
              
            } else {
              message("No reference species yet.")
            }
          }
)

setMethod("plot.Path2PPI",
          signature="Path2PPI",
          definition=function(x,type="ppi",multiple.edges=FALSE,scores=FALSE,
                              species.colors=c(),vertices.opacity=0.8,
                              use.identifiers=FALSE,protein.labels=NA,
                              show.legend=TRUE,vertices.coordinates=NA,
                              return.coordinates=FALSE,tkplot=FALSE,...)
          {
            path2ppi <- x
            
            if (nrow(getPPI(path2ppi))==0) stop("No predicted PPI yet. Please 
                                                call predictPPI-method first!")
            if (type!="hybrid" & type!="ppi") stop("Wrong network type!")
            
            #Some genereal plot setting
            if (!exists("vertex.size")) vertex.size = 10
            if (!exists("vertex.label.dist")) vertex.label.dist = 0
            if (!exists("vertex.label.degree")) vertex.label.degree = -pi/4
            if (!exists("vertex.label.cex")) vertex.label.cex = 0.8
            if (!exists("vertex.label.color")) vertex.label.color=rgb(
              0.1,0.1,0.1)
            if (!exists("edge.label.cex")) edge.label.cex = 0.8
            if (!exists("edge.label.color")) edge.label.color=rgb(0.2,0.2,0.2)
            if (!exists("vertex.frame.color")) vertex.frame.color=NA
            if (!exists("vertex.label.font")) vertex.label.font=2
            if (!exists("vertex.label.family")) vertex.label.family="sans"
            if (!exists("edge.label.family")) edge.label.family="sans"
            
            
            
            edges <- c("interaction"="solid","homology"="dotted")
            
            if (type=="hybrid") { #Hybrid
              titel <- paste(path2ppi@pathway," in ", .getTaxName(
                path2ppi@targetSpecies)," (",.getTaxId(path2ppi@targetSpecies),
                ") - Hybrid",collapse="",sep="")
              
              g <- getHybridNetwork(path2ppi,igraph=TRUE)
              species <- unique(get.vertex.attribute(g,"Species"))
              
              #Check if user defined COLORS
              if (length(species.colors)>0) {
                species <- setdiff(species,names(species.colors))
                if (length(species) > 0)
                  warning("Species colors vector is not complete. 
                          Default colors were added.")
                temp <- species
                species <- rainbow(length(species))
                names(species) <- temp
                species.colors <- c(species.colors,species)
              }
              else {
                species.colors <- rainbow(length(species))
                names(species.colors) <- species
              }
              
              vertex.color <- as.character(
                species.colors[get.vertex.attribute(g,"Species")])
              edges.color <- as.character(species.colors[get.edge.attribute(
                g,"t.species.id")])
              edges.type <- as.character(edges[get.edge.attribute(g,"type")])
              
              
              
              if (scores) {
                edges.labels <- round(get.edge.attribute(g,"score"),digits=2)
                
                if (type=="hybrid")
                  edges.labels[get.edge.attribute(g,"t.species.id")!=
                                 .getTaxId(path2ppi@targetSpecies)&
                                 get.edge.attribute(g,"type")==
                                 "interaction"]<-NA
                
              } else
                edges.labels <- NA
              
              par(cex.main = 1)
              
              if (is.matrix(vertices.coordinates))
                coordinates <- vertices.coordinates
              else
                coordinates <- layout.auto(g,weight=E(g)$score)
              
            } else { #PPI
              
              if (multiple.edges) {
                titel <- paste(path2ppi@pathway," in ", 
                               .getTaxName(path2ppi@targetSpecies)," (",
                               .getTaxId(path2ppi@targetSpecies),
                               ") - PPI detailed",collapse="",sep="")
                
                g <- getPPI(path2ppi,raw=TRUE,igraph=TRUE)
                
                species <- unique(get.edge.attribute(g,"r.species"))
                species <- c(.getTaxId(path2ppi@targetSpecies),c(species))
                
                #Check if user defined COLORS
                if (length(species.colors)>0) {
                  species <- setdiff(species,names(species.colors))
                  if (length(species) > 0)
                    warning("Species colors vector is not complete. Default 
                            colors were added.")
                  temp <- species
                  species <- rainbow(length(species))
                  names(species) <- temp
                  species.colors <- c(species.colors,species)
                }
                else {
                  species.colors <- rainbow(length(species))
                  names(species.colors) <- species
                }
                vertex.color <- species.colors[1]
                edges.color <- as.character(
                  species.colors[get.edge.attribute(g,"r.species")])
                
              }
              else {
                titel <- paste(path2ppi@pathway," in ", .getTaxName(
                  path2ppi@targetSpecies),
                  " (",.getTaxId(path2ppi@targetSpecies)
                  ,") - PPI",collapse="",sep="")
                
                g <- getPPI(path2ppi,raw=FALSE,igraph=TRUE)
                
                if ((length(species.colors)==0) || !((.getTaxId(
                  path2ppi@targetSpecies) %in% names(species.colors)))) {
                  if (length(species.colors)>0) 
                    warning("Color for target species is not defined in color 
                            vector. Default color is used.")
                  vertex.color <- edges.color <- rainbow(1)
                } else
                  vertex.color <- edges.color <- 
                  species.colors[.getTaxId(path2ppi@targetSpecies)]
              }
              
              edges.type <- "solid"
              
              par(cex.main = 1)
              if (is.matrix(vertices.coordinates))
                coordinates <- vertices.coordinates
              else
                coordinates <- layout.auto(g,weight=E(g)$score)
              
              if (scores)
                edges.labels <- round(get.edge.attribute(g,"score"),digits=2)
              else
                edges.labels <- NA
              
            }
            
            vertex.color <- adjustcolor(vertex.color, vertices.opacity) 
            
            #Get labels
            labels <- get.vertex.attribute(g,"name")
            names(labels) <- labels
            if (!use.identifiers) {
              #Replace with available reference species labels
              for (i in 1:length(path2ppi@referenceContainer@species)) {
                proteins <- showReferences(path2ppi,i,"proteins")
                labels[names(labels) %in% rownames(proteins)] <- 
                  proteins[
                    names(labels[names(labels) %in% rownames(proteins)]), 1]
              }
              
              if (!is.null(names(protein.labels))) {
                labels[names(labels) %in% names(protein.labels)] <- 
                  protein.labels[names(labels[names(labels) %in% 
                                                names(protein.labels)])]
              }
            }
            
            if (tkplot)
              tkplot(g,vertex.label=labels,vertex.label.font=vertex.label.font,
                     layout=coordinates,vertex.color=vertex.color,
                     vertex.label.color=vertex.label.color,
                     vertex.label.dist=vertex.label.dist,
                     vertex.label.degree=vertex.label.degree,
                     vertex.size=vertex.size,vertex.label.cex=vertex.label.cex,
                     vertex.label.family=vertex.label.family,
                     edge.label.family=edge.label.family,
                     vertex.frame.color=vertex.frame.color, 
                     edge.color=edges.color,edge.lty=edges.type,
                     edge.width=ceiling(E(g)$score),edge.label=edges.labels,
                     edge.label.cex=edge.label.cex,
                     edge.label.color=edge.label.color,main=titel,asp=0,
                     edge.loop.angle=pi,margin=0,...)
            else {
              plot(g,vertex.label=labels,vertex.label.font=vertex.label.font,
                   layout=coordinates,vertex.color=vertex.color,
                   vertex.label.color=vertex.label.color,
                   vertex.label.dist=vertex.label.dist,
                   vertex.label.degree=vertex.label.degree,
                   vertex.size=vertex.size,vertex.label.cex=vertex.label.cex,
                   vertex.label.family=vertex.label.family,
                   edge.label.family=edge.label.family,
                   vertex.frame.color=vertex.frame.color,
                   edge.color=edges.color,
                   edge.lty=edges.type,edge.width=ceiling(E(g)$score),
                   edge.label=edges.labels,edge.label.cex=edge.label.cex,
                   edge.label.color=edge.label.color,main=titel,asp=0,
                   edge.loop.angle=pi,margin=0,...)
              if ((type=="ppi") && !multiple.edges) show.legend=FALSE
              if (show.legend) legend("bottomright",names(species.colors),
                                      col=species.colors, pch=19, cex=0.8,
                                      bty="o", text.col=rgb(0.2,0.2,0.2))
            }
            
            if (return.coordinates) {
              return (coordinates)
            }
          }
)


setMethod("getHybridNetwork", "Path2PPI",
          function(path2ppi, igraph=FALSE) {
            used.homologues <- data.frame(
              source.id=
                c(path2ppi@raw.ppi$source.id,path2ppi@raw.ppi$target.id), 
              target.id=c(path2ppi@raw.ppi$r.species.s, 
                          path2ppi@raw.ppi$r.species.t),
              t.species.id=rep(path2ppi@raw.ppi$r.species,2),
              score=c(path2ppi@raw.ppi$h.scoreA,path2ppi@raw.ppi$h.scoreB),
              type="homology", stringsAsFactors=FALSE)
            used.homologues <- used.homologues[!duplicated(
              used.homologues[,c(1,2)]),]
            
            #All used interactions
            used.interactions <- data.frame(
              source.id=path2ppi@raw.ppi$r.species.s,
              target.id=path2ppi@raw.ppi$r.species.t,
              t.species.id=path2ppi@raw.ppi$r.species,
              score=1,type="interaction", stringsAsFactors=FALSE)
            used.interactions <- used.interactions[!duplicated(
              used.interactions[,c(1,2)]),]
            
            hybrid <- rbind(used.homologues, used.interactions, 
                            data.frame(source.id=path2ppi@ppi$source.id,
                                target.id=path2ppi@ppi$target.id,
                                t.species.id=.getTaxId(path2ppi@targetSpecies),
                                score=path2ppi@ppi$score,type="interaction", 
                                stringsAsFactors=FALSE))
            
            if (igraph) {
              targetId <- .getTaxId(path2ppi@targetSpecies)
              taxIds <- setdiff(unique(hybrid$t.species.id),targetId)
              
              vertices <- list()
              #First, get all target species nodes
              temp <- hybrid[which(hybrid$t.species.id==targetId),
                             c("source.id","target.id")]
              vertices[[targetId]] <- 
                c(hybrid[which(hybrid$type=="homology"),"source.id"],
                  temp[,"source.id"],temp[,"target.id"])
              vertices[[targetId]] <- 
                vertices[[targetId]][!duplicated(vertices[[targetId]])]
              
              #Then each reference species node
              for (s in 1:length(taxIds)) {
                temp <- hybrid[
                  (hybrid$type=="interaction") & 
                    (hybrid$t.species.id==taxIds[s]),
                  c("source.id","target.id")]
                vertices[[taxIds[s]]] <- 
                  c(hybrid[(hybrid$type=="homology")&
                             (hybrid$t.species.id==taxIds[s]),"target.id"],
                    temp[,"source.id"],temp[,"target.id"])
                vertices[[taxIds[s]]] <- 
                  vertices[[taxIds[s]]][!duplicated(vertices[[taxIds[s]]])]
              }
              
              vertices <- data.frame(ID=do.call(c,vertices),
                                     Species=rep(names(vertices),
                                                 lapply(vertices,length)),
                                     stringsAsFactors=FALSE)
              
              return (graph.data.frame(hybrid, directed=FALSE, 
                                       vertices=vertices))
            } else
              return (hybrid)
          }
)


setMethod("getPPI", "Path2PPI",
          function(path2ppi, raw=FALSE, igraph=FALSE) {
            #, igraph=TRUE
            
            if (igraph) {
              all.vertices <- c(path2ppi@ppi[,1],path2ppi@ppi[,2])
              all.vertices <- unique(all.vertices)
              
              vertices <- data.frame(ID=all.vertices,stringsAsFactors=FALSE)
              if (raw)
                return (graph.data.frame(path2ppi@raw.ppi[,-11], 
                                         directed=FALSE,
                                         vertices=vertices))
              else
                return (graph.data.frame(path2ppi@ppi[,-5], directed=FALSE, 
                                         vertices=vertices))
            } else {
              if (raw)
                return (path2ppi@raw.ppi[,-11])
              else
                return (path2ppi@ppi[,-5])
            }
          }
          
)


setMethod("showInteraction", "Path2PPI",
          function(path2ppi, interaction, mode="default", verbose=TRUE) {
            index <- which((path2ppi@ppi$source.id==interaction[1]&
                            path2ppi@ppi$target.id==interaction[2])|
                           (path2ppi@ppi$source.id==interaction[2]&
                            path2ppi@ppi$target.id==interaction[1]))
            if (length(index) == 0)
              message("Interaction not found!")
            else {
              #default, detailed, references, references.detailed              
              
              temp.ppi <- path2ppi@ppi[index,]
              raw.indices <- unlist(strsplit(as.character(temp.ppi[,5]),",",
                                             fixed=TRUE))
              temp.raw <- path2ppi@raw.ppi[raw.indices,]
              
              counts <- table(temp.raw$r.species)
              
              if (verbose) {
                cat("Score: ",temp.ppi[,"score"],"\n",sep="")
                cat(nrow(temp.raw), " reference interactions: ",sep="")
                
                for (i in 1:nrow(counts))
                  cat(names(counts)[i]," (",counts[i],") ",sep="")
                cat("\n")
              }
              
              
              if ((mode=="default") && !verbose)
                return (temp.ppi[,-5])
              if (mode=="detailed")
                return (temp.raw)
              if (mode=="references") {
                for (i in 1:nrow(counts)) {
                  if (i==1)
                    df <- cbind(species=names(counts)[i],
                          .getReferenceInteractions(
                            path2ppi@referenceContainer, names(counts)[i],
                            temp.raw[which(temp.raw$r.species==
                                             names(counts)[i]),"ref"],
                  FALSE))
                  else
                    df <- rbind(df,cbind(species=names(counts)[i],
                    .getReferenceInteractions(path2ppi@referenceContainer,
                    names(counts)[i],
                    temp.raw[which(temp.raw$r.species==names(counts)[i]),
                             "ref"],
                    FALSE)))
                }
                
                return (df)
              }
              if (mode=="references.detailed") {
                for (i in 1:nrow(counts)) {
                  if (i==1)
                    df <- .getReferenceInteractions(
                      path2ppi@referenceContainer, names(counts)[i], 
                      temp.raw[which(temp.raw$r.species==names(counts)[i]), 
                               "ref"],
                    TRUE)
                  else
                    df <- rbind(df,
                          .getReferenceInteractions(
                            path2ppi@referenceContainer, names(counts)[i], 
                            temp.raw[which(temp.raw$r.species==
                                             names(counts)[i]),"ref"],
                    TRUE))
                }
                return (df)
              }                
              
            }
          }
          
)


setMethod("predictPPI", "Path2PPI",
          function(path2ppi,mode,h.thresh,h.range,i.thresh,consider.complexes,
                   max.complex.size,decline.self.interaction.ref,
                   decline.self.interaction.tar,verbose) {
            
            .combineScores <- function(x,k=length(x)) {
              #Recursive function, e.g.:
              #x <- c(0.6,0.7,0.9)
              #0.9 + (1-0.9)*0.7 + (1-(0.9+(1-0.9)*0.7))*0.6  
              if (k == 1) return (x[k])
              else {
                if (k == length(x)) sort(x)
                return (.combineScores(x,k-1)+(1-.combineScores(x,k-1))*x[k])
              }
            }
            
            if (max.complex.size==0) consider.complexes=FALSE
            
            taxIds <- .getAllTaxIds(path2ppi@referenceContainer)
            id.counter <- 0 
            ppi <- data.frame(id=numeric(),source.id=character(),
                              target.id=character(),score=numeric(),
                              h.scoreA=numeric(), h.scoreB=numeric(), 
                              r.species=character(),r.species.s=character(),
                              r.species.t=character(), pos.edges=numeric(), 
                              used.edges=numeric(), ref=character(), 
                              stringsAsFactors=FALSE)
            
            #For each species
            for (s in 1:length(taxIds)) { 
              taxId <- taxIds[s]
              taxName <- .getTaxName(path2ppi@referenceContainer,taxId)
              
              if (verbose) message("Begin with ",taxName,sep="")
              
              #Get relevant interactions
              interactions <- .getInteractions(path2ppi@referenceContainer,
                                               taxId,mode,consider.complexes,
                                               max.complex.size)
              
              if (decline.self.interaction.ref) 
                interactions <- interaction[
                  !(interactions$A.accession==interactions$B.accession),
                  ]
              
              n <- 0 #Counter for adopted interactions
              for (i in 1:nrow(interactions)) { 
                
                pA_r <- as.character(interactions$A.accession[i])
                pB_r <- as.character(interactions$B.accession[i])
                
                pA_t <- .getHomologs(path2ppi@targetSpecies,taxId,pA_r,"t")
                pB_t <- .getHomologs(path2ppi@targetSpecies,taxId,pB_r,"t")
                
                if (nrow(pA_t) == 1) hpA.one2one <- TRUE 
                else hpA.one2one <- FALSE
                if (nrow(pB_t) == 1) hpB.one2one <- TRUE 
                else hpB.one2one <- FALSE
                
                #At least one homologous for each protein
                if ((nrow(pA_t) > 0) && (nrow(pB_t) > 0)) { 
                  pos.edges <- 0
                  used.edges <- 0
                  for (pA_t_one in 1:nrow(pA_t)) {
                    for (pB_t_one in 1:nrow(pB_t)) {
                      if (!decline.self.interaction.tar || 
                            (pA_t[pA_t_one,1]!=pB_t[pB_t_one,1])) {
                        
                        #Compute both HomPairScores (hp.score) for each 
                        #Homologue pair if only one homologue was found than 
                        #the score is 1 otherwise it is computed by a linear 
                        #function            
                        if ((hpA.one2one) && (pA_t[pA_t_one,2] <= h.thresh)) 
                          hp.scoreA <- 1 
                        else 
                          hp.scoreA <- homologyScore(pA_t[pA_t_one,2],h.range)
                        if ((hpB.one2one) && (pB_t[pB_t_one,2] <= h.thresh)) 
                          hp.scoreB <- 1 
                        else 
                          hp.scoreB <- homologyScore(pB_t[pB_t_one,2],h.range)
                        
                        #Each score has to be above 0
                        if ((hp.scoreA > 0) && (hp.scoreB > 0)) {
                          pos.edges<-pos.edges+1
                          score <- (hp.scoreA+hp.scoreB)/2
                        }
                        else
                          score <- 0
                        
                        if (score >= i.thresh) {
                          n<-n+1
                          used.edges<-used.edges+1
                          id.counter<-id.counter+1
                          ppi <- rbind(ppi, 
                                       data.frame(id=id.counter, 
                                                  source.id=pA_t[pA_t_one,1],
                                                  target.id=pB_t[pB_t_one,1],
                                                  score=score,
                                                  h.scoreA=hp.scoreA, 
                                                  h.scoreB=hp.scoreB, 
                                                  r.species=taxId,
                                                  r.species.s=pA_r,
                                                  r.species.t=pB_r,
                                                  pos.edges=-1,
                                                  used.edges=-1, 
                                                  ref=interactions[i,"ref"], 
                                                  stringsAsFactors=FALSE))
                          
                        } 
                      }  
                    }
                  }
                  
                  if (nrow(ppi) > 0) {
                    #How many edges were possible from this refrence species 
                    #protein pair (regarding the degree of homology fits)
                    ppi[ppi$pos.edges==-1,"pos.edges"] <- pos.edges 
                    #How many edges were left after new compute score which 
                    #have to be >= i.thresh
                    ppi[ppi$used.edges==-1,"used.edges"] <- used.edges 
                  }        
                }
              }
              
              if (verbose) message(paste(i, 
                                " interactions processed. These lead",
                                " to ", n," interactions in target species.",
                                collapse="",sep=""))
              if (verbose) message("-------------------------------")
              
            } 
            
            #Combine, remove redundancies and increment counter
            save.ppi <- ppi  
            combine.equal.interactions.order <- c()
            
            if (verbose) message("Combine results to one single PPI.")
            
            #New container with combined results
            c.ppi <- data.frame(source.id=character(),target.id=character(),
                                score=numeric(),r.species=character(),
                                reference=character(), stringsAsFactors=FALSE) 
            
            repeat { #For each founded interaction in target species
              
              pA <- ppi[1,"source.id"] #Start (id)
              pB <- ppi[1,"target.id"] #Target (id)
              
              #Find each similar edge
              temp.indices <- 
                which(ppi[,"source.id"]==pA & ppi[,"target.id"]==pB, 
                      arr.ind = TRUE) 
              #vice versa (ie start = target and target = start)
              temp.indices.r <- 
                which(ppi[,"source.id"]==pB & ppi[,"target.id"]==pA, 
                      arr.ind = TRUE) 
              
              #Combine all edges
              if (length(temp.indices.r) > 0) 
                temp.indices <- c(temp.indices, temp.indices.r) 

              #In case of self-interaction (For wach self-interaction two 
              #edges a generated, hence, remove the each second:  A-A would 
              #be found in temp.indices and temp.indices.r
              temp.indices <- unique(temp.indices)
              
              temp.interactions <- ppi[temp.indices,] #Temp. save similar edges

              #In which reference species?
              in.which.species <- unique(temp.interactions$r.species) 
              
              references <- c()
              scores <- c()
              for (i in 1:length(in.which.species)) 
                scores <- c(scores,.combineScores(
                  temp.interactions[temp.interactions[,"r.species"]==
                                      in.which.species[i],"score"]))
              
              references <- 
                c(references, 
                  ((length(combine.equal.interactions.order)+1):
                     (length(combine.equal.interactions.order)+
                        nrow(temp.interactions))))
              combine.equal.interactions.order <- 
                c(combine.equal.interactions.order,temp.interactions[,"id"])
              
              avg.score <- mean(scores, na.rm = TRUE)
              inter.score <- avg.score + length(scores)-1
              
              cur.row <- data.frame(source.id=pA, target.id=pB,
                                    score=inter.score,
                                    r.species=paste(sort(in.which.species),
                                                    collapse=","),
                                    reference=paste(references,collapse=","),
                                    stringsAsFactors=FALSE)                
              
              c.ppi <- rbind(c.ppi, cur.row)

              #Remove current interaction (and all similar) from container and 
              #proceed
              ppi <- ppi[-temp.indices,] 
              
              if (nrow(ppi)==0) {
                if (verbose) 
                  message(paste("A total of ",nrow(c.ppi), 
                                " putative interactions were predicted in ",
                                "target species.",collapse="",sep=""))
                break
              }
              
            }
            
            save.ppi <- save.ppi[combine.equal.interactions.order,-1]
            c.ppi <- c.ppi[order(c.ppi$score,decreasing = TRUE),]
            rownames(save.ppi) <- 1:nrow(save.ppi)
            rownames(c.ppi) <- 1:nrow(c.ppi)
            
            path2ppi@raw.ppi <- save.ppi
            path2ppi@ppi <- c.ppi
            
            path2ppi@h.thresh <- h.thresh
            path2ppi@h.range <- h.range
            path2ppi@i.thresh <- i.thresh
            path2ppi@consider.complexes <- consider.complexes
            path2ppi@max.complex.size <- max.complex.size
            
            
            return (path2ppi)
            
          }  
)

setMethod("removeReference",
          signature="Path2PPI",
          definition=function(path2ppi,species)
          {
            path2ppi@referenceContainer <- 
              .removeReferenceSpecies(path2ppi@referenceContainer,species)
            path2ppi@targetSpecies <- 
              .removeHomologs(path2ppi@targetSpecies,species)
            
            path2ppi
          }
)

homologyScore <- function(e.value,h.range) {
  dist <- log10(h.range[1])-log10(h.range[2])
  m <- 1/(dist)
  b <- -(log10(h.range[2])/dist)
  return (sapply(e.value, function(e) if (e >= h.range[2]) 0 
                 else if (e <= h.range[1]) 1 else round(m*log10(e)+b,2)))
}

setMethod("show", 
          signature=".ReferenceSpecies",
          definition=function(object)
          {
            titel <- paste(
              object@taxName," (TaxId: ",object@taxId,")\n",collapse="",sep="")
            cat(titel)
            cat(paste(rep("-",nchar(titel)),collapse=""),"\n")
            
            cat(nrow(object@proteins)," proteins (",
                nrow(object@proteins[!object@proteins$used,]),
                " not used)\n",sep="")
            cat(nrow(object@interactions)," interactions:\n",sep="")
            
            both <- nrow(object@interactions[
              object@interactions$A.in.prot.list & 
                object@interactions$B.in.prot.list,])
            one <- nrow(object@interactions[
              object@interactions$A.in.prot.list | 
                object@interactions$B.in.prot.list,])
            complex.interactions <- nrow(object@interactions[
              object@interactions$A.db=="complex",])
            complexes <- length(unique(as.character(object@interactions[
              object@interactions$A.db=="complex","ref"])))
            cat("- ",both,
                " interactions have both interactors in protein list.\n",
                sep="")
            cat("- ",
                one," interactions have at least one ", 
                "interactor in protein list.\n",sep="")
            cat("- ",complex.interactions," interactions in ",
                complexes," protein complexes.\n",sep="")
            #}
            
            
          }
)

setMethod("show",
          signature=".ReferenceContainer",
          definition=function(object)
          {
            
            if (length(object@species) > 0) {
              cat("This reference container contains ",length(object@species),
                  " species:\n\n")
              for (i in 1:length(object@species)) {
                show(object@species[[i]])
                cat("\n")
              }
            }
            else
              cat("No reference-species in container yet.\n")
            
          }
)

setMethod("show",
          signature=".TargetSpecies",
          definition=function(object)
          {
            cat("Target species: ",object@taxName,"\n")
            cat("----------------------------------------------------\n")
            if (length(object@homologs) > 0) {
              for (i in 1:length(object@homologs)) {
                cat(nrow(object@homologs[[i]]), "homologous relationships to 
                    species with taxonomy id ", names(object@homologs)[i],"\n")
              }
            }
            else
              cat("No homologous relationships in container yet.\n")
            if (length(object@proteins) > 0) 
              cat("Relevant proteins: ",length(object@proteins),"\n")
            else
              cat("No relevant proteins yet.\n")
          }
)

setMethod("show",
          signature="Path2PPI",
          definition=function(object)
          {
            titel <- paste(object@pathway," in ", 
                           .getTaxName(object@targetSpecies)," (",
                           .getTaxId(object@targetSpecies),")\n",collapse="",
                           sep="")
            cat(titel)
            cat(paste(rep("-",nchar(titel)),collapse=""),"\n")
            r.species.n <- .countSpecies(object@referenceContainer)
            if (r.species.n > 0) 
              cat(.countSpecies(object@referenceContainer),
                  " reference species: ",
                  paste(.getAllTaxIds(object@referenceContainer),
                        collapse=", "),"\n",sep="")
            else
              cat("No reference species yet.\n")
            cat(paste(rep("-",nchar(titel)),collapse=""),"\n")
            if (nrow(object@ppi)>0) {
              #cat(paste(rep("-",nchar(titel)),collapse=""),"\n")
              hybrid <- getHybridNetwork(object)
              n.predicted <- 
                which(hybrid$t.species.id==.getTaxId(object@targetSpecies))
              proteins.n <- 
                length(unique(c(hybrid[n.predicted,1],hybrid[n.predicted,2])))
              
              hybrid <- hybrid[-n.predicted,]
              n.predicted <- length(n.predicted)
              r.species <- unique(hybrid$t.species.id)
              cat("Number of predicted proteins: ",proteins.n,"\n",sep="")
              cat("Number of predicted interactions: ",n.predicted,"\n",sep="")
              cat("Predicted PPI based on ",
                  .countSpecies(object@referenceContainer),
                  " reference species:\n",sep="")
              for (i in 1:length(r.species))
                cat(r.species[i]," (",
                    length(which(hybrid$t.species.id==
                                   r.species[i]&hybrid$type=="interaction")),
                    " interactions and ",
                    length(which(hybrid$t.species.id==
                                   r.species[i]&hybrid$type=="homology")),
                    " homologous relations)\n",sep="")
              cat(paste(rep("-",nchar(titel)),collapse=""),"\n")
              cat("Settings:\n",sep="")
              cat("Homology threshold: ",object@h.thresh,"\n",sep="")
              cat("Homology range: [",object@h.range[1],",",
                  object@h.range[2],"]\n",sep="")
              cat("Interactions threshold: ",object@i.thresh,"\n",sep="")
              cat("Consider complexes: ",object@consider.complexes,"\n",sep="")
              if (object@consider.complexes)
                cat("Max. complex size: ",object@max.complex.size,"\n",sep="")
              
            } else
              cat("No predicted PPI yet.\n")
            
          }
)

setMethod(".getProteins", ".ReferenceSpecies",
          function(object) {
            
            return (object@proteins)
          }
)


setMethod(".getTaxId", ".ReferenceSpecies",
          function(object) {
            return(object@taxId)
          }
)


setMethod(".getTaxName", ".ReferenceSpecies",
          function(object) {
            return(object@taxName)
          }
)



setMethod(".getReferenceInteractions", ".ReferenceSpecies",
          function(object, ref, detailed=FALSE) {
            are.all.in <- ref %in% object@interactions$ref
            
            if (!all(are.all.in))
              message("Could not find some of the references: ",
                  paste(ref[!are.all.in], collapse=", "), sep="")
            if (detailed)
              return (object@irefindex[object@irefindex$irigid %in% ref,])
            else
              return (object@interactions[object@interactions$ref %in% ref,])
          }
)

setMethod(".getInteractions", ".ReferenceSpecies",
          function(object, mode="both", consider.complexes=FALSE,
                   max.complex.size=10) {
            warning.number <- 1000
            
            who.is.complex <- object@interactions$A.db == "complex"
            complexes <- object@interactions[who.is.complex,]
            interactions <- object@interactions[!who.is.complex,]
            interactions$complex <- FALSE
            
            if (mode == "both") {
              interactions <- 
                interactions[interactions$A.in.prot.list &
                               interactions$B.in.prot.list,]
            }
            
            if (nrow(interactions)>=warning.number) {
              message("Warning: Large network, may take a long time to 
                      compute!\nYour settings will lead to approximately ",
                      nrow(interactions), " interactions in this reference 
                      species.\nIt is recommended to reduce the size of the 
                      protein list or by using the \"both\"-mode.")
              line <- readline("Proceed anyway (y/n)?")
              
              if (line == "n")
                stop("Canceled by user.")
              else
                warning.number <- 100000000 #Ignore second warning
            }            
            
            if (consider.complexes) {
              #Get each complex size
              all.complexes <- table(as.character(complexes$A.accession))
              #Remove complexes which are to large
              all.complexes <- 
                names(all.complexes[all.complexes <= max.complex.size]) 
              
              if (mode == "both") {
                #Keep only those where all participants are in prot list
                which.complexes.have.all <- sapply(all.complexes, function(x) 
                  all(complexes[complexes$A.accession == x,"B.in.prot.list"]))
                all.complexes <- all.complexes[which.complexes.have.all]
              }
              
              complexes <- complexes[as.character(complexes$A.accession) 
                                     %in% all.complexes,]
              
              if (nrow(complexes)>0) {
                approx.number.of.interactions <- 
                  sum(choose(table(as.character(complexes$A.accession)), 2)) +
                  nrow(interactions)
                
                if (approx.number.of.interactions>=warning.number) {
                  message("Warning: Large network, may take a long time to 
                          compute!\n",
                          paste("Your settings will lead to approximately ",
                                approx.number.of.interactions,
                                " interactions in this reference species.\nIt 
                                is recommended to reduce complex size or use 
                                the \"both\"-mode.", collapse=""))
                  line <- readline("Proceed anyway (y/n)?")
                  
                  if (line == "n")
                    stop("Canceled by user.")
                }
                
                #Now translate to interaction list and add to interactions
                all.complexes <- unique(as.character(complexes$A.accession))
                
                for (a in 1:length(all.complexes)) {
                  temp.complexes <- 
                    complexes[complexes$A.accession == all.complexes[a],]
                  if (nrow(temp.complexes)>1) {
                    combinations <- 
                      t(combn(as.character(temp.complexes$B.accession),2))
                      temp.complex.df <- data.frame(ref=temp.complexes$ref[1],
                                                A.db="",
                                                A.accession=combinations[,1],
                                                A.in.prot.list=FALSE,B.db="",
                                                B.accession=combinations[,2],
                                                B.in.prot.list=NA,
                                                stringsAsFactors=FALSE)
                      for (b in 1:nrow(temp.complexes)) {
                         fill <- temp.complexes[b, c("B.db", "B.in.prot.list")]
                         fill[, 1] <- as.character(fill[, 1])
                         temp.complex.df[which(temp.complex.df$A.accession ==
                                               temp.complexes$B.accession[b]),
                                        c("A.db", "A.in.prot.list")] <- fill
                         temp.complex.df[which(temp.complex.df$B.accession ==
                                               temp.complexes$B.accession[b]),
                                        c("B.db", "B.in.prot.list")] <- fill
                      }
                  
                      temp.complex.df$complex <- TRUE
                      interactions <- rbind(interactions, temp.complex.df)
                  }
                }
              }
              
            }
            
            return (interactions)
          }           
)

setMethod(".addReferenceSpecies", ".ReferenceContainer",
          function(object, taxName, taxId, proteins, irefindex.file) {
            if (!is.character(proteins)) #Not a character vector
              stop ("Proteins list is not a character vector!")
            
            if (is.null(names(proteins))) { #Not a named vector
              if (any(duplicated(proteins))) 
                stop ("Ambiguous entries in your proteins list detected!", 
                      " Please remove duplicated IDs first.")
              proteins <- data.frame(proteins=proteins, row.names=proteins,
                                     stringsAsFactors=FALSE)
            }
            else { #Is a named vector
              proteins <- data.frame(proteins=proteins,
                                     row.names=names(proteins),
                                     stringsAsFactors=FALSE)
            }
            
            if (taxId %in% names(object@species))
              stop ("TaxID ",taxId," already in container!")
            
            species <- .ReferenceSpecies(
              taxId, taxName, proteins, irefindex.file)
            object@species[[taxId]] <- species
            
            return (object)
          }
)


setMethod(".removeReferenceSpecies", ".ReferenceContainer",
          function(object, species) {
            if ((class(species) == "numeric") && 
                  ((species < 0) || (species > length(object@species))))
              stop ("Invalid index!")
            
            if ((class(species) == "character") && 
                  !(species %in% names(object@species)))
              stop ("Species with taxId ", species, " not in container!")
            
            object@species[[species]] <- NULL
            
            return (object)
          }
)


setMethod(".getInteractions", ".ReferenceContainer",
          function(object, taxId, mode="both", consider.complexes=FALSE,
                   max.complex.size=10) {
            return (.getInteractions(object@species[[taxId]],mode,
                                     consider.complexes,max.complex.size))
          }
)

setMethod(".getReferenceInteractions", ".ReferenceContainer",
          function(object,taxId,ref,detailed=FALSE) {
            return (.getReferenceInteractions(object@species[[taxId]],
                                              ref,detailed))
          }
)


setMethod(".getAllTaxIds", ".ReferenceContainer",
          function(object) {
            return (names(object@species))
          }
)

setMethod(".getTaxName", ".ReferenceContainer",
          function(object,taxId) {
            return(.getTaxName(object@species[[taxId]]))
          }
)


setMethod(".getReferenceSpecies", ".ReferenceContainer",
          function(object,species,info,detailed) {
            if (is.numeric(species) && 
                  ((species > length(object@species)) || (species < 0)))
              stop("Wrong species number!")
            if (is.character(species) && 
                  !(species %in% names(object@species)))
              stop("Wrong TaxId!")
            
            if (info)
              show(object@species[[species]])
            else
              return (object@species[[species]])
          }
)


setMethod(".getSourceDBs", ".ReferenceContainer",
          function(object, irefindex) {
            temp <- table(irefindex[,"sourcedb"])
            dbs <- data.frame(db.id=gsub(".*:(.*)\\(.*", "\\1", 
                                         names(temp)),
                              db.name=gsub(".*\\((.*)\\).*", "\\1", 
                                           names(temp)),count=as.numeric(temp))
            
            return (dbs)
          }
)


setMethod(".countSpecies", ".ReferenceContainer",
          function(object) {
            return (length(object@species))
          }
)


setMethod(".getHomologs", ".TargetSpecies",
          function(object,taxId,proteins=NA,is.source.or.target="t") {
            if (is.na(proteins))
              return (object@homologs[[taxId]])
            else {
              if (is.source.or.target == "t")
                return (object@homologs[[taxId]]
                        [object@homologs[[taxId]][,2] %in% proteins,c(1,11)])
              else
                return (object@homologs[[taxId]]
                        [object@homologs[[taxId]][,1] %in% proteins,c(2,11)])
            }
          }
)


setMethod(".addHomologs", ".TargetSpecies",
          function(object,taxId,homologs) {
            object@homologs[[taxId]] <- homologs
            
            return (object)
          }
)



setMethod(".removeHomologs", ".TargetSpecies",
          function(object,species) {
            if ((class(species) == "numeric") 
                && ((species < 0) || (species > length(object@homologs))))
              stop ("Invalid index!")
            
            if ((class(species) == "character") 
                && !(species %in% names(object@homologs)))
              stop ("Species with taxId ",species," not in container!")
            
            object@homologs[[species]] <- NULL
            
            return (object)
          }
)


setMethod(".getTaxId", ".TargetSpecies",
          function(object) {
            return (object@taxId)
          }  
)

setMethod(".getTaxName", ".TargetSpecies",
          function(object) {
            return (object@taxName)
          }  
)

#PRIVATE CLASSES

# CLASS REFERENCE SPECIES

.ReferenceSpecies <- setClass(".ReferenceSpecies",
    representation(
        taxId = "character",
        taxName = "character",
        proteins = "data.frame",
        irefindex = "data.frame",
        interactions = "data.frame"
    )
)

# CLASS REFERENCE CONTAINER
.ReferenceContainer <- setClass(".ReferenceContainer",
    representation(
        species = "list"
    ),
    prototype=list(
    )
)

# CLASS TARGET SPECIES
.TargetSpecies <- setClass(".TargetSpecies",
    representation(
        taxId = "character",
        taxName = "character",
        proteins = "character",
        homologs = "list"
    )
)

#PUBLIC CLASSES

# CLASS Path2PPI

Path2PPI <- setClass("Path2PPI",
    representation(
        pathway = "character",
        targetSpecies = ".TargetSpecies",
        referenceContainer = ".ReferenceContainer",
        h.thresh = "numeric",
        h.range = "numeric",
        i.thresh = "numeric",
        consider.complexes = "logical",
        max.complex.size = "numeric",
        raw.ppi = "data.frame",
        ppi = "data.frame"
    ),

    prototype=list(
      targetSpecies = NULL,
      referenceContainer = NULL,
      h.thresh = 1e-5,
      h.range = c(1e-100,1e-20),
      i.thresh = 0.7,
      consider.complexes = FALSE,
      max.complex.size = 5
    )
)

# Privates

setGeneric(".getProteins", 
           function(object) {
             standardGeneric(".getProteins")
           }
)

setGeneric(".getTaxId", 
           function(object,...) {
             standardGeneric(".getTaxId")
           }
)

setGeneric(".getTaxName", 
           function(object,...) {
             standardGeneric(".getTaxName")
           }
)

setGeneric(".getInteractions", 
           function(object,...) {
             standardGeneric(".getInteractions")
           }
)

setGeneric(".getReferenceInteractions", 
           function(object,...) {
             standardGeneric(".getReferenceInteractions")
           }
)

setGeneric(".addReferenceSpecies", 
           function(object,taxName,taxId,proteins,irefindex.file) {
             standardGeneric(".addReferenceSpecies")
           }
)


setGeneric(".removeReferenceSpecies", 
           function(object,species) {
             standardGeneric(".removeReferenceSpecies")
           }
)

setGeneric(".getAllTaxIds", 
           function(object) {
             standardGeneric(".getAllTaxIds")
           }
)

setGeneric(".getReferenceSpecies", 
           function(object,species,info=FALSE,detailed=FALSE) {
             standardGeneric(".getReferenceSpecies")
           }
)

setGeneric(".getSourceDBs", 
           function(object, irefindex) {
             standardGeneric(".getSourceDBs")
           }
)

setGeneric(".countSpecies", 
           function(object) {
             standardGeneric(".countSpecies")
           }
)

setGeneric(".getHomologs", 
           function(object,taxId,...) {
             standardGeneric(".getHomologs")
           }
)

setGeneric(".addHomologs", 
           function(object,taxId,homologs) {
             standardGeneric(".addHomologs")
           }
)

setGeneric(".removeHomologs", 
           function(object,species) {
             standardGeneric(".removeHomologs")
           }
)

# Publics

setGeneric("addReference", 
           function(path2ppi,taxName,taxId,proteins,irefindex, homologs) {
             standardGeneric("addReference")
           }
)

setGeneric("showReferences", 
           function(path2ppi,species=NA,returnValue=NA) {
             standardGeneric("showReferences")
           }
)

setGeneric("plot.Path2PPI", 
           function (x,type="ppi",multiple.edges=FALSE,scores=FALSE,
                     species.colors=c(),vertices.opacity=0.8,
                     use.identifiers=FALSE,protein.labels=NA,show.legend=TRUE,
                     vertices.coordinates=NA,return.coordinates=FALSE,
                     tkplot=FALSE,...) {
             standardGeneric("plot.Path2PPI")
           }
)

setGeneric("getHybridNetwork", 
           function(path2ppi, igraph=FALSE) {
             standardGeneric("getHybridNetwork")
           }
)

setGeneric("getPPI", 
           function(path2ppi, raw=FALSE, igraph=FALSE) {
             standardGeneric("getPPI")
           }
)

setGeneric("showInteraction", 
           function(path2ppi,interaction, mode="default", verbose=TRUE) {
             standardGeneric("showInteraction")
           }
)

setGeneric("predictPPI", 
           function(path2ppi,mode="both",h.thresh=1e-5,h.range=c(1e-100,1e-20),
                    i.thresh=0.7,consider.complexes=FALSE,max.complex.size=5,
                    decline.self.interaction.ref=FALSE,
                    decline.self.interaction.tar=TRUE,verbose=TRUE) {
             standardGeneric("predictPPI")
           }
)

setGeneric("removeReference", 
           function(path2ppi,species) {
             standardGeneric("removeReference")
           }
)

setMethod ("initialize", ".ReferenceSpecies", 
           function(.Object, taxId, taxName, proteins, irefindex) {
             
             #Load file
             if (!is.data.frame(irefindex)) {
               message("Load interaction file and search for all relevant 
                   interactions:")
               message("0%")
               irefindex <- read.table(irefindex, sep="\t", comment.char = "",
                                       header=TRUE, quote="",
                                       stringsAsFactors=FALSE)
             } else {
               message("Search for all relevant interactions:")
               message("0%", appendLF = FALSE)
             }

             #Only interspecies interactions
             taxA <- grepl(taxId, irefindex$taxa)
             taxB <- grepl(taxId, irefindex$taxb)
             irefindex <- 
               irefindex[(taxA & taxB) | (grepl("-", irefindex$taxa) & taxB),]
             #Temporary remove duplicates (due different DBs)
             
             if (colnames(irefindex)[1]=="X.uidA") 
               interactions <- 
               irefindex[!duplicated(irefindex[, c("X.uidA", "uidB")]),]
             else
               interactions <- 
               irefindex[!duplicated(irefindex[, c("uidA", "uidB")]),]
             
             rownames(interactions) <- 1:nrow(interactions)
             message("--25%", appendLF = FALSE)             
             
             #Interactor A
             
             if (colnames(irefindex)[1]=="X.uidA") 
               idA <- apply(interactions[, 
                                         c("X.uidA", "altA", 
                                           "OriginalReferenceA", 
                                           "FinalReferenceA", 
                                           "aliasA")], 1, paste, collapse="|")
             else
               idA <- apply(interactions[, 
                                         c("uidA", "altA", 
                                           "OriginalReferenceA", 
                                           "FinalReferenceA", 
                                           "aliasA")], 1, paste, collapse="|")
             
             idA <- strsplit(idA, "|", fixed=TRUE)
             idA <- data.frame(ref=rep(rownames(interactions), 
                                       lapply(idA,length)), temp=unlist(idA),
                               stringsAsFactors=FALSE)  
             idA <- cbind(idA, do.call(rbind, 
                                       strsplit(idA$temp, ":", fixed=TRUE)))
             idA <- idA[, -2]
             colnames(idA) <- c("ref", "database", "accession")
             idA <- idA[!duplicated(idA[, c("ref", "accession")]),]
             message("--50%", appendLF = FALSE)
             #Interactor B
             idB <- apply(interactions[, c("uidB", "altB", 
                                           "OriginalReferenceB", 
                                           "FinalReferenceB","aliasB")],
                          1, paste,collapse="|")
             idB <- strsplit(idB, "|", fixed=TRUE)
             idB <- data.frame(
               ref=rep(rownames(interactions), lapply(idB,length)), 
               temp=unlist(idB), stringsAsFactors=FALSE)  
             idB <- cbind(idB, do.call(rbind, 
                                       strsplit(idB$temp, ":", fixed=TRUE)))
             idB <- idB[,-2]
             colnames(idB) <- c("ref", "database", "accession") 
             idB <- idB[!duplicated(idB[, c("ref", "accession")]),]  
             message("--75%", appendLF = FALSE)
             
             #Find relevant complex ids using B interactors
             
             inB <- idB[idB$accession %in% 
                          c(rownames(proteins), proteins[,1]), "ref"]
             inB <- unique(inB)
             complexes <- as.character(
               idA[(idA$ref %in% inB) &
                     (idA$database == "complex"), "accession"])
             
             #All relevant lines in A
             inA <- idA[idA$accession %in% 
                          c(rownames(proteins),proteins[,1], complexes), "ref"]
             
             #Combine all relavant lines
             cmbn <- unique(c(inA, inB))
             
             #Reduce A and B to the relevant lines...
             idA <- idA[idA$ref %in% cmbn,]
             idB <- idB[idB$ref %in% cmbn,]
             
             idA[, 3] <- as.character(idA[, 3])
             idA[, 2] <- as.character(idA[, 2])
             idB[, 3] <- as.character(idB[, 3]) 
             idB[, 2] <- as.character(idB[, 2])
             
             #Additionally search for the aliases and replace with the 
             #original ids
             for (i in 1:nrow(proteins)) {
               temp <- which(idA[, 3] == proteins[i, 1])
               idA[temp, 3] <- rownames(proteins)[i]
               idA[temp, 2] <- "replaced"
               temp <- which(idB[, 3] == proteins[i, 1])
               idB[temp, 3] <- rownames(proteins)[i]
               idB[temp, 2] <- "replaced"              
             }
             
             #...and prepare for the filtering one id per entry
             idA$inProtList <- idA$accession %in% rownames(proteins)
             idB$inProtList <- idB$accession %in% rownames(proteins)
             
             #First only keep non-duplicates, complexes and those in orgin list
             idA <- idA[!duplicated(idA$ref) | (idA$database == "complex") | 
                          idA$inProtList,]
             idB <- idB[!duplicated(idB$ref) | idB$inProtList,]
             
             #Then remove duplicates from last, this will keep those which are 
             #in origin list but not the major id (assign by irefindex)
             idA <- idA[!duplicated(idA$ref, fromLast=TRUE),]
             idB <- idB[!duplicated(idB$ref, fromLast=TRUE),]
             
             #Combine
             both <- cbind(idA, idB)
             both[, 1] <- interactions[both[, 1], "irigid"]
             both <- both[, -5]
             colnames(both) <- c("ref", "A.db", "A.accession", 
                                 "A.in.prot.list", "B.db", "B.accession", 
                                 "B.in.prot.list")
             
             irefindex <- irefindex[irefindex$irigid %in% both$ref,]
             
             proteins$used <- rownames(proteins) %in% 
               c(as.character(both$A.accession), 
                 as.character(both$B.accession))
             message("--100%")
             
             not.used <- rownames(proteins[!proteins$used,])
             if (length(not.used) > 0) {
              message("Could not find interactions for",
                      " some of the proteins:\n",
                      paste(not.used,collapse=", "))
             }
             
             .Object@taxId <- taxId
             .Object@taxName <- taxName
             .Object@proteins <- proteins
             .Object@interactions <- both
             .Object@irefindex <- irefindex
             
             .Object
           }
)

setMethod ("initialize", ".ReferenceContainer", 
           function(.Object) {
             .Object
           }
)

setMethod ("initialize", ".TargetSpecies", 
           function(.Object, taxName, taxId) {
             if (is.na(taxName))
               stop("Please enter a title for the target species.")
             .Object@taxName <- taxName
             .Object@taxId <- taxId
             
             .Object
           }
)

setMethod ("initialize", "Path2PPI", 
           function(.Object, pathway, targetName, targetId) {
             
             if(missing(pathway)) 
               stop("Please specify a name for the pathway.")
             if(missing(targetName)) 
               stop("Please specify a name for the target species.")
             if(missing(targetId)) 
               stop("Please specify an identifier for the target species.")
             
             .Object@pathway=pathway
             .Object@referenceContainer <- .ReferenceContainer()
             .Object@targetSpecies <- .TargetSpecies(targetName, targetId)
             
             .Object
           }
)

\name{ai}
\alias{ai}
\alias{human.ai.irefindex}
\alias{human.ai.proteins}
\alias{pa2human.ai.homologs}
\alias{yeast.ai.irefindex}
\alias{yeast.ai.proteins}
\alias{pa2yeast.ai.homologs}
\docType{data}
\title{
Data set to predict autophagy induction in \emph{Podospora anserina}
}
\description{
This data set consists of all data files necessary to predict the putative 
interactions of the induction step of autophagy in \emph{Podospora anserina} 
by means of the corresponding PPIs in human and yeast.
}
\usage{data("ai")}
\format{
    human.ai.irefindex: Data frames with 1694 observations of 54 variables.
    yeast.ai.irefindex: Data frames with 3840 observations of 54 variables.
    pa2human.ai.homologs: Data frames with 261 observations of 12 variables.
    pa2yeast.ai.homologs: Data frames with 98 observations of 12 variables.
    human.ai.proteins: Named character vector with 5 elements.
    yeast.ai.proteins: Named character vector with 7 elements.
}
\details{
    Data frames \code{human.ai.irefindex} and \code{yeast.ai.irefindex} 
    consists of all relevant interactions of the corresponding iRefIndex 
    files. The two data frames \code{pa2human.ai.homologs} and 
    \code{pa2yeast.ai.homologs} are the necessary parts of the result files 
    from the BLAST searches of the \emph{P. anserina} proteom against the 
    proteoms of human and yeast. The named character vectors 
    \code{human.ai.proteins} and \code{yeast.ai.proteins} consists of the 
    proteins involved in the induction process of autophagy in human and 
    yeast.
}

\references{
Camacho, C. et al. (2009). BLAST+: architecture and applications. BMC 
Bioinformatics, 10(1), 421.

Razick, S. et al. (2008). iRefIndex: a consolidated protein interaction 
database with provenance. BMC Bioinformatics, 9(1), 405.
}
\examples{
data(ai)
}
\value{
Four data frames and two named character vectors (see above).
}

\keyword{datasets}

\name{showInteraction}
\alias{showInteraction}
\alias{showInteraction-methods}

\title{
Information about an interaction
}
\description{
Use \code{showInteraction} to get detailed information about one 
interaction of the predicted PPI.
}
\usage{
showInteraction(path2ppi, interaction, mode="default", verbose=TRUE)
}
\arguments{
\item{path2ppi}{
An object from the class \code{Path2PPI}.
}
\item{interaction}{
Character vector consisting of the identifiers of the two interactors.
}
\item{mode}{
Character string. Which information of this interaction is requested. 
"default": only the predicted interaction and some major information are 
provided. "detailed": all interactions deduced from each reference species 
with this interaction is provided. "references": each reference interaction 
of the current interaction with some major information. "references.detailed": 
each reference interaction of the current interaction with all available 
information (extracted from the corresponding iRefIndex data set).
}
\item{verbose}{
Logical. \code{FALSE} hides messages in the output.
}
}

\value{
Data frame with the requested information defined in \code{mode}.
}

\author{
Oliver Philipp \email{MolBI-software@bioinformatik.uni-frankfurt.de}
}

\seealso{
\code{\link{plot.Path2PPI}},\code{\link{showReferences}}
}
\examples{
data(ai) #Load test data set

ppi <- Path2PPI("Autophagy induction", "Podospora anserina", "5145")
ppi <- addReference(ppi, "Homo sapiens", "9606", human.ai.proteins, 
                    human.ai.irefindex, pa2human.ai.homologs)
ppi <- addReference(ppi, "Saccharomyces cerevisiae (S288c)", "559292", 
                    yeast.ai.proteins, yeast.ai.irefindex, 
                    pa2yeast.ai.homologs)
                    
ppi <- predictPPI(ppi,h.range=c(1e-60,1e-20))

interaction <- showInteraction(ppi,interaction=c("B2AT71","B2AE79"),
mode="detailed")
interaction
}

\name{homologyScore}
\alias{homologyScore}

\title{
Computes homology scores
}
\description{
Computes the homology scores based on the BLAST E-value. This function is used 
by the \code{predictPPI} method to compute homology scores to decide whether 
an interaction in a reference species is adopted to the target species 
(see package vignette for a detailed description). It can be used to test 
which E-values lead to which scores given a predefined E-value range.
}
\usage{
homologyScore(e.value, h.range)
}

\arguments{
    \item{e.value}{
    One BLAST E-value or a numeric vector with different BLAST E-values
    }
    \item{h.range}{
    Numeric vector consisting of two values. The first value indicates the 
    lower bound (smallest E-value). Each E-value which is equal or less 
    than this bound is scored with 1. The second value indicates the 
    upper bound (biggest E-value). Each E-value which is equal or greater than 
    this bound is scored with 0.
    }
}
\details{
Uses a linear function to map the E-value \eqn{v} to the range \eqn{[l,u]} 
where \eqn{l} is the lower and \eqn{u} the upper bound:


\deqn{s(v)=|m\log_{10}(v)+b|}{s(v)=|m*log_10(v)+b|}
\deqn{m=\frac{1}{\log_{10}(l)-\log_{10}(u)}}{m=1/(log_10(l)-log_10(u))}
\deqn{b=-(m\log_{10}(u))}{b=-(m*log_10(u))}


}
\value{
Numeric vector containing the scores.
}
\author{
Oliver Philipp \email{MolBI-software@bioinformatik.uni-frankfurt.de}
}

\seealso{
\code{\link{predictPPI}}
}
\examples{
l <- 1e-100                                   #lower bound
u <- 1e-20                                    #upper bound
h.range <- c(l,u)                             #define range
e.values <- c(1e-20,1e-40,1e-60,1e-80,1e-100) #some BLAST E-values

homologyScore(e.values,h.range)
}

\name{getPPI}
\alias{getPPI}

\title{
Get predicted PPI
}
\description{
Get the predicted PPI of an \code{Path2PPI} object consisting of each 
predicted interaction and protein in the target species.
}
\usage{
getPPI(path2ppi, raw=FALSE, igraph=FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{path2ppi}{
An object of the class \code{Path2PPI}.
}
  \item{raw}{
Logical; if \code{TRUE} then the detailed view of the predicted PPI will be 
returned. That means that each predicted interaction deduced from each 
reference species is given. In contrast, \code{FALSE} leads to the actually 
predicted and combined PPI where no redundancies occur.
}
  \item{igraph}{
Logical; if \code{TRUE} then the returned PPI is given as igraph-object. 
Otherwise a data frame with each predicted interaction will be returned.
}
}

\value{
See \code{igraph} argument.
}

\author{
Oliver Philipp \email{MolBI-software@bioinformatik.uni-frankfurt.de}
}


\seealso{
\code{\link{getHybridNetwork}}
}
\examples{
data(ai) #Load test data set

ppi <- Path2PPI("Autophagy induction", "Podospora anserina", "5145")

ppi <- addReference(ppi, "Homo sapiens", "9606", human.ai.proteins, 
                    human.ai.irefindex, pa2human.ai.homologs)
ppi <- addReference(ppi, "Saccharomyces cerevisiae (S288c)", "559292", 
                    yeast.ai.proteins, yeast.ai.irefindex, 
                    pa2yeast.ai.homologs)

ppi <- predictPPI(ppi)

#Get the predicted PPI as data frame.
network <- getPPI(ppi)

#Get the detailed predicted PPI as data frame.
network.raw <- getPPI(ppi,raw=TRUE)
}

\name{addReference}
\alias{addReference}

\title{
Add reference species
}
\description{
Adds reference species to an object from the class \code{Path2PPI}.
}
\usage{
addReference(path2ppi, taxName, taxId, proteins, irefindex, homologs)
}

\arguments{
\item{path2ppi}{
An object of the class \code{Path2PPI}.
}
\item{taxName}{
A character string giving the taxonomy name.
}
\item{taxId}{
A character string giving the taxonomy identifier.
}
\item{proteins}{
Either a character vector with the identifiers of the proteins which are 
involved in the corresponding pathway or a character vector with the protein 
names or aliases, respectively, named by the protein identifiers.
}
\item{irefindex}{
Either a data frame, representing the iRefIndex table of the current reference 
species, e.g. loaded previously via \code{read.table}, or the corresponding 
file name of the iRefIndex file.
}
\item{homologs}{
Either a data frame representing the results of the BLAST search (e.g. loaded 
previously via \code{read.table}) or the corresponding file name of the BLAST 
result file.
}
}
\details{
This method searches for all relevant interactions in the data frame or file 
defined in iRefIndex. There are different and often ambiguous protein 
identifiers defined in an iRefIndex file, and the putative "major" identifiers 
are not necessarily those defined in the corresponding "major" columns "uidA" 
and "uidB". Furthermore, iRefIndex also contains protein complexes. Hence, 
\code{Path2PPI} applies an advanced search algorithm to automatically find  
relevant interactions associated with the pathway or the proteins of interest, 
respectively. The user does not have to predefine the identifiers types 
(Uniprot, Swissprot, Ensemble etc.), since these types are often unambiguously 
assigned. The algorithm searches for each identifier in 10 columns where any 
type of identifier or accession number is defined ("uidA", "altA", 
"OriginalReferenceA", "FinalReferenceA", "aliasA", "uidB", "altB", 
"OriginalReferenceB", "FinalReferenceB" and "aliasB"). Additionally, it 
searches for each complex which contains one or more of the predefined 
proteins. Subsequently, each homologous relationship which is not relevant for 
the previously found interactions is declined. The results of these searches 
are centralized in the \code{Path2PPI} object and can be visualized using the 
appropriate methods (e.g. \code{\link{showReferences}})
}
\value{
An object from the class \code{Path2PPI} with attached reference species.
}

\author{
Oliver Philipp \email{MolBI-software@bioinformatik.uni-frankfurt.de}
}


\seealso{
\code{\link{showReferences}}, \code{\link{removeReference}}
}
\examples{
data(ai) #Load test data set

ppi <- Path2PPI("Autophagy induction", "Podospora anserina", "5145")
ppi

ppi <- addReference(ppi, "Homo sapiens", "9606", human.ai.proteins, 
                    human.ai.irefindex, pa2human.ai.homologs)
ppi <- addReference(ppi, "Saccharomyces cerevisiae (S288c)", "559292", 
                    yeast.ai.proteins, yeast.ai.irefindex, 
                    pa2yeast.ai.homologs) 
ppi
}

\name{plot.Path2PPI}
\alias{plot.Path2PPI}

\title{
Plots the predicted PPI
}
\description{
Plots the predicted PPI in three different ways. Depending on the \code{type} 
argument it manages the specific layout settings and finally uses the plot 
function of the \code{\link{igraph}} package.
}
\usage{
\method{plot}{Path2PPI}(x, type = "ppi", multiple.edges = FALSE, 
              scores = FALSE, species.colors = c(), 
              vertices.opacity=0.8, use.identifiers=FALSE,
              protein.labels = NA, show.legend = TRUE, 
              vertices.coordinates = NA, return.coordinates = FALSE, 
              tkplot=FALSE,...)
}
\arguments{
\item{x}{
An object from the class \code{Path2PPI} where the PPI network already has 
been predicted.
}
\item{type}{
Character string. Which graph type to plot. "ppi": plots only the predicted 
PPI. "hybrid": plots the hybrid network which consists of all relevant 
interactions from the reference species, the predicted interactions in the 
target species and all relevant homologous relationships.
}
\item{multiple.edges}{
Logical. Is only considered if \code{type="ppi"}. If \code{TRUE} then each 
reference interaction is depicted in the species-specific color (raw mode), 
in contrast, if set to \code{FALSE} only the finalized / combined interactions 
are depicted.
}
\item{scores}{
Logical. If \code{TRUE} the edge scores will be shown.
}
\item{species.colors}{
Named vector, to specify the species colors. If no value is given then default 
colors are used.
}
  \item{vertices.opacity}{
Numeric value between 0 and 1 defining the opacity of the vertices.
}
\item{use.identifiers}{
Logical. If \code{TRUE} then only the proteins identifiers are used as the 
vertex labels.
}
\item{protein.labels}{
Named vector to define the labels of the vertices. If no value is given then 
the protein identifiers are used. The vector does not have to be complete, 
i.e. not each protein has to be defined.
}
\item{show.legend}{
Logical. If \code{TRUE} then a legend is depicted.
}
\item{vertices.coordinates}{
Data frame containing the coordinates of the vertices. If no value is given 
then coordinates are computed using the \code{\link{layout.auto}} function.
}
\item{return.coordinates}{
Logical. If \code{TRUE} the coordinates of the vertices are returned.
}
\item{tkplot}{
Logical. If \code{TRUE} the graph is drawn in the interactive graph drawing
facility \code{\link{tkplot}}.
}
\item{\dots}{
Additional plotting parameters.
}
}
\details{
The argument \code{return.coordinates} only works correctly if 
\code{tkplot=FALSE}. If you want to get the coordinates of the tkplot device 
use \code{\link{tkplot.getcoords}}.
}

\note{
If you want to export the plotted graph to postscript you have to consider
that the default font family is set to \emph{sans} for vertex and edge labels.
Please change the default font family of postscript to \emph{sans} before you 
call the plot method: \code{ps.options(family="sans")}.
Additionally, you have to consider that the default value for 
\code{vertices.opacity} is set to \emph{0.8} in order to enhance the 
visibility of the graph, since some edges may be hidden by the vertices. 
Postscript does not support semi-transparencies. Hence, please change the 
\code{vertices.opacity} argument to \emph{1} if you want to export the graph 
using postscript.
}

\value{
If \code{return.coordinates=TRUE} the coordinates of the vertices are 
returned.
}

\author{
Oliver Philipp \email{MolBI-software@bioinformatik.uni-frankfurt.de}
}

\seealso{
\code{\link{predictPPI}}, \code{\link{igraph}} for other plotting parameters
}
\examples{
data(ai) #Load test data set

ppi <- Path2PPI("Autophagy induction", "Podospora anserina", "5145")
ppi <- addReference(ppi, "Homo sapiens", "9606", human.ai.proteins, 
                    human.ai.irefindex, pa2human.ai.homologs)
ppi <- addReference(ppi, "Saccharomyces cerevisiae (S288c)", "559292", 
                    yeast.ai.proteins, yeast.ai.irefindex, 
                    pa2yeast.ai.homologs)

ppi <- predictPPI(ppi,h.range=c(1e-60,1e-20))

#Plot the predicted PPI with the default settings and return 
#the coordinates of the vertices
set.seed(12)
coordinates <- plot(ppi, return.coordinates=TRUE)

#Plot the predicted PPI and show each underlying reference interaction. 
#Use different species specific colors. To compare both graphs, 
#use the coordinates computed before
plot(ppi,multiple.edges=TRUE,vertices.coordinates=coordinates)

#Plot the corresponding hybrid network with predefined species colors.
#Also define some labels for the proteins of the target species.
#Keep in mind: You can not use the data in "coordinates" since 
#the hybrid network consists of more vertices than the default PPI
set.seed(40)
target.labels<-c("B2AE79"="PaTOR","B2AXK6"="PaATG1",
                "B2AUW3"="PaATG17","B2AM44"="PaATG11",
                "B2AQV0"="PaATG13","B2B5M3"="PaVAC8")
species.colors <- c("5145"="red","9606"="blue","559292"="green")
plot(ppi,type="hybrid",species.colors=species.colors,
protein.labels=target.labels)
}

\name{removeReference}
\alias{removeReference}

\title{
Remove reference species
}
\description{
Remove reference species previously attached to an object from the class 
\code{Path2PPI}.
}
\usage{
removeReference(path2ppi, species)
}

\arguments{
  \item{path2ppi}{
An object from the class \code{Path2PPI}.
}
  \item{species}{
Either a number between 1 and the number of stored reference species or a 
character string with the taxonomy id of the reference species to remove.
}
}

\value{
An object of the class \code{Path2PPI} with removed reference species 
\code{species}.
}

\author{
Oliver Philipp \email{MolBI-software@bioinformatik.uni-frankfurt.de}
}

\seealso{
\code{\link{showReferences}}, \code{\link{addReference}}
}
\examples{
data(ai) #Load test data set

ppi <- Path2PPI("Autophagy induction", "Podospora anserina", "5145")

ppi <- addReference(ppi, "Homo sapiens", "9606", human.ai.proteins, 
                    human.ai.irefindex, pa2human.ai.homologs)
ppi <- addReference(ppi, "Saccharomyces cerevisiae (S288c)", "559292", 
yeast.ai.proteins, yeast.ai.irefindex, pa2yeast.ai.homologs) 

#Remove second reference species
ppi <- removeReference(ppi,2)

#Remove reference species with taxonomy id "9606"
ppi <- removeReference(ppi,"9606") 

}

\name{getHybridNetwork}
\alias{getHybridNetwork}

\title{
Get hybrid network of the predicted PPI
}
\description{
Get the hybrid network of the previously predicted PPI. The hybrid network 
consists of all relevant interactions from the reference species, the 
predicted interactions in the target species and all relevant homologous 
relationships.
}
\usage{
getHybridNetwork(path2ppi, igraph = FALSE)
}

\arguments{
    \item{path2ppi}{
         An object of the class \code{Path2PPI}.
         }
    \item{igraph}{
         Logical; if \code{TRUE} then the hybrid network is given as 
         igraph-object. Otherwise a data frame, consisting of each 
         interaction and homologous relationship, will be returned.
    }
}

\value{
See \code{igraph} argument.
}

\author{
Oliver Philipp \email{MolBI-software@bioinformatik.uni-frankfurt.de}
}


\seealso{
\code{\link{getPPI}}
}
\examples{
data(ai) #Load test data set

ppi <- Path2PPI("Autophagy induction", "Podospora anserina", "5145")

ppi <- addReference(ppi, "Homo sapiens", "9606", human.ai.proteins, 
                    human.ai.irefindex, pa2human.ai.homologs)
ppi <- addReference(ppi, "Saccharomyces cerevisiae (S288c)", "559292", 
                    yeast.ai.proteins, yeast.ai.irefindex, 
                    pa2yeast.ai.homologs)

ppi <- predictPPI(ppi)

#Return the hybrid network as data frame
hybrid <- getHybridNetwork(ppi)

#Return the hybrid network as igraph object
hybrid <- getHybridNetwork(ppi,igraph=TRUE)
}

\name{Path2PPI-class}
\Rdversion{1.1}
\docType{class}
\alias{Path2PPI-class}
\alias{Path2PPI}
\alias{addReference,Path2PPI-method}
\alias{getHybridNetwork,Path2PPI-method}
\alias{getPPI,Path2PPI-method}
\alias{initialize,Path2PPI-method}
\alias{plot.Path2PPI,Path2PPI-method}
\alias{predictPPI,Path2PPI-method}
\alias{removeReference,Path2PPI-method}
\alias{show,Path2PPI-method}
\alias{showInteraction,Path2PPI-method}
\alias{showReferences,Path2PPI-method}


\title{Class \code{"Path2PPI"}}
\description{
An instance of the class \code{Path2PPI} is the major object in the Path2PPI 
package. It manages all reference species and the target species. 
The prediction algorithm is implemented in this class as well.
}
\usage{
Path2PPI(...)
}

\arguments{
  \item{...}{Argument list (see Note below).}
}


\section{Slots}{
  \describe{
    \item{\code{pathway}:}{Object of class \code{"character"} }
    \item{\code{targetSpecies}:}{Object of class \code{".TargetSpecies"} }
    \item{\code{referenceContainer}:}{Object of class 
    \code{".ReferenceContainer"} }
    \item{\code{h.thresh}:}{Object of class \code{"numeric"} }
    \item{\code{h.range}:}{Object of class \code{"numeric"} }
    \item{\code{i.thresh}:}{Object of class \code{"numeric"} }
    \item{\code{consider.complexes}:}{Object of class \code{"logical"} }
    \item{\code{max.complex.size}:}{Object of class \code{"numeric"} }
    \item{\code{raw.ppi}:}{Object of class \code{"data.frame"} }
    \item{\code{ppi}:}{Object of class \code{"data.frame"} }
  }
}

\section{Methods}{
  \describe{
    \item{\code{\link{addReference}}}{\code{signature(path2ppi = "Path2PPI")} }
    \item{\code{\link{getHybridNetwork}}}{
    \code{signature(path2ppi = "Path2PPI")} }
    \item{\code{\link{getPPI}}}{\code{signature(path2ppi = "Path2PPI")} }
    \item{\code{\link{initialize}}}{\code{signature(.Object = "Path2PPI")} }
    \item{\code{\link{plot.Path2PPI}}}{\code{signature(x = "Path2PPI")} }
    \item{\code{\link{predictPPI}}}{\code{signature(path2ppi = "Path2PPI")} }
    \item{\code{\link{removeReference}}}{
    \code{signature(path2ppi = "Path2PPI")} }
    \item{\code{\link{show}}}{\code{signature(object = "Path2PPI")} }
    \item{\code{\link{showInteraction}}}{
    \code{signature(path2ppi = "Path2PPI")} }
    \item{\code{\link{showReferences}}}{
    \code{signature(path2ppi = "Path2PPI")} }
   }
}


\value{
An instance of the class \code{Path2PPI}.
}


\note{
Arguments to \code{Path2PPI()} and the \code{\link{new}} method are obligatory 
and must be named if they differ from this order:
\tabular{ll}{
  \strong{pathway} \tab A character string with the name of the pathway which 
  has to be predicted.\cr
  \strong{targetName} \tab A character string giving the taxonomy name of the 
  target species.\cr
  \strong{targetId} \tab A character string giving the taxonomy identifier of 
  the target species.\cr
}
}

\author{
Oliver Philipp \email{MolBI-software@bioinformatik.uni-frankfurt.de}
}

\examples{
ppi <- Path2PPI("Autophagy induction", "Podospora anserina", "5145")
ppi
}

\name{showReferences}
\alias{showReferences}

\title{
Information about reference species
}
\description{
Get information about the currently stored reference species. If indicated by 
\code{returnValue} a data frame - containing information about each protein or 
interaction - is provided as well.
}
\usage{
showReferences(path2ppi, species = NA, returnValue = NA)
}

\arguments{
\item{path2ppi}{
An object from the class \code{Path2PPI}.
}
\item{species}{
Either a number between 1 and the number of stored reference species or a 
character string with the taxonomy id. If no value for \code{species} is given 
then information about each stored reference species is provided.

}
\item{returnValue}{
Character value indicating whether to return a value. "proteins": a data frame 
containing the proteins associated with the pathway of interest in the  
corresponding reference species. "interactions": a data frame containing all 
processed, relevant and non-redundant interactions. "irefindex": a data frame 
containing all relevant interactions in the raw irefindex format. Is only 
reasonable if \code{species} is defined. If no value for \code{returnValue} is 
given then only general information is provided.
}
}

\value{
See description for \code{returnValue}
}

\author{
Oliver Philipp \email{MolBI-software@bioinformatik.uni-frankfurt.de}
}

\seealso{
\code{\link{addReference}}, \code{\link{removeReference}}, 
\code{\link{showInteraction}}
}
\examples{
data(ai) #Load test data set

ppi <- Path2PPI("Autophagy induction", "Podospora anserina", "5145")

ppi <- addReference(ppi, "Homo sapiens", "9606", human.ai.proteins, 
                    human.ai.irefindex, pa2human.ai.homologs)
ppi <- addReference(ppi, "Saccharomyces cerevisiae (S288c)", "559292", 
                    yeast.ai.proteins, yeast.ai.irefindex, 
                    pa2yeast.ai.homologs) 

#Get general information about each stored reference species
showReferences(ppi)

#Get general information about reference species with the taxonomy id "9606"
showReferences(ppi, species="9606")

#Get all proteins associated with the pathway of interest 
#and previously given by the user
proteins <- showReferences(ppi, species="9606", returnValue="proteins")

#Get all processed and non-redundant interactions previously 
#determined to be relevant for the pathway of interest
interactions <- showReferences(ppi, species="9606", returnValue="interactions")

#Get all relevant interactions in the detailed irefindex format
irefindex <- showReferences(ppi, species="9606", returnValue="irefindex")


}

\name{predictPPI}
\alias{predictPPI}

\title{
Prediction of the PPI
}
\description{
Major method of the \code{Path2PPI} class to predict the final PPI in the 
target species using the information available from the stored reference 
species. Different values for the arguments of this method can lead to 
different PPI networks, differing in the degree of reliability and strictness.
}
\usage{
predictPPI(path2ppi, mode="both", h.thresh=1e-05, 
           h.range=c(1e-100, 1e-20), i.thresh=0.7, 
           consider.complexes=FALSE, max.complex.size=5,
           decline.self.interaction.ref=FALSE,
           decline.self.interaction.tar=TRUE,
           verbose=TRUE)
}

\arguments{
  \item{path2ppi}{
An object of the class \code{Path2PPI}.
}
  \item{mode}{
Which interaction from the reference species should be taken into account. 
"both": both interactors of an interaction has to be in the initial protein 
list previously inserted by the user (recommended if it is a large network or 
many proteins were initially defined, respectively). "one": only one of the 
interactors of each reference interaction has to be in the initial protein 
list (may lead to very large networks).
}
  \item{h.thresh}{
E-value cutoff at which each homologous relationship definitely will be 
declined (see also \code{h.range} argument).
}
  \item{h.range}{
Numeric vector consisting of two values. The first value indicates the lower 
border (smallest E-value). Each E-value which is equal or less than this 
border is scored with 1 (best). The second value indicates the upper border 
(biggest E-value). Each E-value which is equal or greater than this border is 
scored with 0 (worst). 
}
  \item{i.thresh}{
Numeric. Threshold for accepted interactions. If the computed prediction score 
for an interaction is less than \code{i.thresh} it will be declined.
}
  \item{consider.complexes}{
Logical. If \code{TRUE} then interactions are also considered which actually 
indicate an association of the current protein to one bigger protein complex. 
This may lead to very large networks if \code{mode="one"} since all other 
proteins of this complex are considered as well, i.e., each protein in such 
complexes are considered to interact with each other protein of this complex. 
If \code{mode="both"} then each protein of an complex has to be in the initial 
protein list to consider each interaction (see details).
}
  \item{max.complex.size}{
Numeric. Is only considered if \code{consider.complexes=TRUE}. The maximum 
size of complexes to be considered. 
}
  \item{decline.self.interaction.ref}{
Logical. If \code{TRUE} then all self interactions from reference species are 
declined.
}
  \item{decline.self.interaction.tar}{
Logical. If \code{TRUE} then all predicted self interactions in target species 
are declined.
}
  \item{verbose}{
Logical. \code{FALSE} hides messages in the output.
}
}
\details{
Difference of \code{h.thresh} and \code{h.range}: If only one protein in the 
target species was found to be homologous to a current reference species 
protein and this homology was rated with an E-value which is equal or smaller 
than \code{h.thresh} it is scored with 1 (even if the E-value is larger than 
the upper border of \code{h.range}). See package vignette for more details.

Use the complex arguments with care, since each complex may lead to a vast 
amount of interactions, i.e., each protein is considered to interact with each 
other of this complex; e.g. if there are 10 proteins involved in one complex, 
this would lead to 10 over 2 = 45 interactions.
}
\value{
An object of the class \code{Path2PPI} with predicted PPI.
}

\author{
Oliver Philipp \email{MolBI-software@bioinformatik.uni-frankfurt.de}
}

\seealso{
\code{\link{plot.Path2PPI}}, \code{\link{homologyScore}}
}
\examples{
data(ai) #Load test data set

ppi <- Path2PPI("Autophagy induction", "Podospora anserina", "5145")
ppi <- addReference(ppi, "Homo sapiens", "9606", human.ai.proteins, 
                    human.ai.irefindex, pa2human.ai.homologs)
ppi <- addReference(ppi, "Saccharomyces cerevisiae (S288c)", "559292", 
                    yeast.ai.proteins, yeast.ai.irefindex, 
                    pa2yeast.ai.homologs)

#Using the default settings leads to 8 predicted interactions in the 
#target species
ppi <- predictPPI(ppi)

#Consider complexes where each complex is allowed to be up to 10 proteins 
#large. For this smaller pathway only one more interaction was predicted when 
#considering larger complexes.
ppi <- predictPPI(ppi,consider.complexes=TRUE,max.complex.size=10)

#We can be less strict and decrease h.range what obviously increases the 
#number of predicted interactions to 13
ppi <- predictPPI(ppi,h.range=c(1e-60,1e-20))
}
